; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    tdata STRUCT
      pbuffer dd ?      ; buffer address
      bufsize dd ?      ; buffer size
      flag    dd ?
    tdata ENDS

    start_fill_thread PROTO :DWORD
    fill_thread  PROTO :DWORD

    .data?
      signal1 dd ?
      signal2 dd ?
      loaded  dd ?

    .code

start:
   
; 

    call main
    inkey
    exit

; 

    memcnt equ <1024*1024*100>

main proc

    LOCAL pmem1 :DWORD
    LOCAL pmem2 :DWORD
    LOCAL tID1  :DWORD
    LOCAL tID2  :DWORD
    LOCAL tdat  :tdata

    mov pmem1, alloc(memcnt)                        ; alocate 2 blocks of memory
    mov pmem2, alloc(memcnt)

  ; -------------------
  ; start 2 new threads
  ; -------------------
    mov eax, pmem1
    mov DWORD PTR tdat.pbuffer, eax
    mov DWORD PTR tdat.bufsize, memcnt              ; 100 meg buffer
    mov DWORD PTR tdat.flag, OFFSET signal1
    mov tID1, rv(start_fill_thread,ADDR tdat)       ; start new thread

    mov eax, pmem2
    mov DWORD PTR tdat.pbuffer, eax
    mov DWORD PTR tdat.bufsize, memcnt              ; 100 meg buffer
    mov DWORD PTR tdat.flag, OFFSET signal2
    mov tID2, rv(start_fill_thread,ADDR tdat)       ; start new thread

    invoke ResumeThread,tID2                        ; activate thread 2
  ; ||||||||||||||||||||||||||||||||||||||||||||||||
  ; fill pmem2 while working on pmem1
  ; ||||||||||||||||||||||||||||||||||||||||||||||||

  ; ************************************
  ; do your own processing here on pmem2
  ; ************************************

  spinlock0:
    invoke SleepEx,1,0
    cmp signal2, 0                                   ; test if thread is finished yet
    jne spinlock0
    print "fill 2 finished",13,10

    invoke ResumeThread,tID1                        ; activate thread 1
  ; ||||||||||||||||||||||||||||||||||||||||||||||||
  ; fill pmem1 while working on pmem2
  ; ||||||||||||||||||||||||||||||||||||||||||||||||

  ; ************************************
  ; do your own processing here on pmem1
  ; ************************************

  spinlock1:
    invoke SleepEx,1,0
    cmp signal1, 0                                   ; test if thread is finished yet
    jne spinlock1
    print "fill 1 finished",13,10

  ; ||||||||||||||||||||||||||||||||||||||||||||||||

    free pmem2
    free pmem1

    invoke TerminateThread,tID1,0
    invoke TerminateThread,tID2,0

    ret

main endp

; 

start_fill_thread proc pstruct:DWORD

    LOCAL tID    :DWORD
    LOCAL thread :DWORD

    mov loaded, 0                       ; clear the loaded flag

    mov thread, rv(CreateThread,0,0,fill_thread,pstruct,0,ADDR tID)

  spinlock:
    invoke SleepEx,1,0
    cmp loaded, 1
    jne spinlock

    print "Thread started",13,10

    mov eax, thread

    ret

start_fill_thread endp

; 

fill_thread proc pstruct:DWORD

    LOCAL pbuf  :DWORD
    LOCAL sbuf  :DWORD
    LOCAL flag  :DWORD

    push ebx
    push esi
    push edi

    mov edi, pstruct

    lea ecx, (tdata PTR [edi]).pbuffer  ; copy structure data to LOCAL
    mov ecx, [ecx]
    mov pbuf, ecx

    lea ecx, (tdata PTR [edi]).bufsize  ; copy structure data to LOCAL
    mov ecx, [ecx]
    mov sbuf, ecx

    mov esi, (tdata PTR [edi]).flag     ; copy structure data to LOCAL

    mov DWORD PTR [esi], 1

    mov loaded, 1                       ; set the loaded flag for the calling proc

  ; *************************************
  @@:
    invoke SuspendThread,rv(GetCurrentThread)
    invoke memfill,pbuf,sbuf,0
    mov DWORD PTR [esi], 0
    jmp @B
  ; *************************************

    pop edi
    pop esi
    pop ebx


    ret

fill_thread endp

; 


end start

























